
package examples.computer;


import simula.*;
import simula.random.* ;
import simula.simset.* ;
import simula.simset.simulation.* ;
import simula.Lang ;

/**
 * Main program for Computer simulation
 * @author Andrea Poltronieri
 * @version 1.0 12 Feb 1998
 */

public class ComputerMain extends SimulationMain {




/**
* @param _simulation The active Simulation
* @exception simula.SimulaException Any exception from Korretto API
*/

	public ComputerMain(Simulation _simulation) throws SimulaException {
	  super(_simulation);
	}
/**     
  * Executes the main program for the simulation
*/
	public void run() {
		try {
			ComputerSimulation sim=(ComputerSimulation)this.sim ;
			// Main
			// init vars 
			sim.inner=new Head() ;
			sim.outer=new Head() ;
			Lang.outtext(" Arrivals frequency [arrivals for unit of time] ?") ;
			sim.arr=Lang.inreal() ;
			Lang.outtext("Number of memory pages in memomry ?") ;
			sim.m=Lang.inint() ;
			Lang.outtext("Lower bound for number of pages requested by jobs ?") ;
			sim.m1=Lang.inint() ;
			Lang.outtext("Upper bound for number of pages requested by jobs ?") ;
			sim.m2=Lang.inint() ;
			Lang.outtext("Time slice given to every process [time units] ?") ;
			sim.s=Lang.inreal() ;
			Lang.outtext(" Probability of job rescheduling after a quantum of service [0..1]?") ;
			sim.q=Lang.inreal() ;
			Lang.outtext(" Seed for random generator (odd) ?") ;
			sim.seed=Lang.inint() ;
			Lang.outtext("Simulation length [time units] ?") ;
			sim.simperiod=Lang.inreal() ;
			
			sim.free=sim.m ;
			sim.result=0 ;
			sim.inner=new Head() ;
			sim.outer=new Head() ;
			
			sim.server=new Server(sim) ;
			sim.activate( new Arrivals(sim) );
			
			sim.hold (sim.simperiod) ;
			
			Lang.outtext("Average number of jobs in the system :");
			Lang.outfix( ((double)(sim.result))/sim.simperiod,3,10) ;			
			sim.end() ;			
			System.exit(0) ;
		} catch(SimulaException e) {
			Lang.outtext(" Exception :> " + e+e.getMessage());
		 System.exit(1);
		}
	}
}