
package examples.machine;


import simula.* ;
import simula.random.* ;
import simula.simset.* ;
import simula.simset.simulation.* ;

/**
 * The machine interference model
 * @author Andrea Poltronieri
 * @version 1.0 12 Feb 1998
 */

public class MachineSimulation extends Simulation{
	// Global vars declaration ;
	/**  Failure ratio */
	public double brk ;
	/** Repairman speed */
	public double rep ;
	/**  Total inactivity time*/
	public double downtime ;
	/** Simulation length */
	public double simtime ;
	/** Number of machines */
	public int m ;
	/** Number of rapairmen*/
	public int r ;
	/** Breaks counter*/
	public int breaks ;
	/** Seed for random generators */
	public int seed ;
	/** Machine counter*/
	public int i ;
	/** Broken machines list*/
	public Head broken ;
	/** Available repairmen list*/
	public Head available ;


/**
 * Print credits on standar error.
 */
private static void credits ( ) {
	System.err.println("***********************************************************") ;
	System.err.println("*                    Example for Korretto                 *") ;
	System.err.println("*  The machine interference model                         *") ;
	System.err.println("* see 'Simulation techiniques for discrete event systems' *") ;
	System.err.println("*      I. Mitrani -- Cambridge University press           *") ;
	System.err.println("*  example 3.2                                            *") ;
	System.err.println("***********************************************************") ;
	System.err.println("*  author : Andrea Poltronieri                            *") ;
	System.err.println("*  Verona University                                      *") ;
	System.err.println("*	e-mail : poltro@arena.sci.univr.it                     *") ;
	System.err.println("*  http://arena.sci.univr.it/~poltro                      *") ;
	System.err.println("***********************************************************") ;
	return;
}
/**     
  * Start the simulation, instantiating a new Simulation and launching the main program
  * @param  args[] Ignored
  * @see simula.simset.simulation.Simulation
  * @see simula.simset.simulation.SimulationMain
*/
public static void main(String args[]) {
	try {
			credits() ;
			MachineSimulation sim = new MachineSimulation();
			MachineMain main = new MachineMain(sim);
		} catch (Exception e) { 
			System.err.println ("Exception caught while lanching Machine  :\n"+e) ;
		}	
	return;
}
}