
package examples.priosys;


import simula.*;
import simula.simset.simulation.*;
import simula.random.* ;
				/**
 * Process wich generate customer arrivals
 * @author Andrea Poltronieri
 * @version 1.0 12 Feb 1998
 */
 
public class Arrivals extends simula.simset.simulation.Process {
	/** Priority level of customers to create */
	int type;



/**
* @param _sim The active Simulation
* @param type Priority category for generated customers ; 1 is the higher.
*/

	public Arrivals (Simulation _sim,int type){
	  super(_sim);
	  this.type=type ;
	}
/**     
  * Executes actions for this object. Called by simulation on activate
  * @see simula.simset.simulation.Simulation
*/


	public void run()  {
		
		PrioSysSimulation sim = (PrioSysSimulation)this.sim ;
		try {
			double arr,ser ;
			Lang.outtext("Initialization of customer type " + this.type+" generator" ) ;
			Lang.outtext("  Arrival rate [arrivals for unit of time] ?") ;
			arr = Lang.inreal() ;
			Lang.outtext("  Service rate [removals for unit of time] ?") ;
			ser = Lang.inreal() ;
			
			// Instantiate random generator
			Negexp negexp1 = new Negexp(sim.seed, arr) ;
			Negexp negexp2 = new Negexp(sim.seed, ser) ;

			// infinite loop 
			while (true) {
				sim.hold(negexp1.draw().asReal()) ;
				sim.activate(new Customer(sim, type, negexp2.draw().asReal())) ;
				//System.out.println("New customer arrived");
			}	
		} catch (Exception e ) { 
			System.err.println ("Exception caught in " + this.toString() + " :\n" + e) ;
			System.exit(1) ;
		}
	}
}