
package examples.warehouse;


import simula.*;
import simula.simset.simulation.*;
import simula.random.* ;
/**
 * Activity concerned with incoming batches
 * @author Andrea Poltronieri
 * @version 1.0 12 Feb 1998
 */

public class Arrivals extends simula.simset.simulation.Process {



/**
* @param _sim The active Simulation
*/
		public Arrivals (Simulation _sim){
		  super(_sim);
		}
/**     
  * Executes actions for this object. Called by simulation on activate
  * @see simula.simset.simulation.Simulation
*/

		public void run()  {
				WareHouseSimulation sim = (WareHouseSimulation) this.sim ;
				Negexp negexp=new Negexp(sim.seed,sim.arr) ;
				Randint randint=new Randint(sim.seed,sim.in1,sim.in2) ;
				//declare local integer for number of items in batch and enter infinite loop
						int number ;
						try {
							while (true) {
								sim.hold(negexp.draw().asReal()) ;
								sim.arrived++ ;
								number = randint.draw().asInteger() ;
								if (number > (sim.m - sim.n)) {
										sim.rejected++;
								}

								else {
										sim.iharea += sim.n * (sim.time() - sim.lastevent);
										sim.lastevent = sim.time();
										sim.n += number;
										if (sim.worker.idle())
												sim.activate(sim.worker);
								}
								//sim.update() ;
								//System.err.println(this.toString()+" running") ;
		
							}
						} catch (Exception e ) {
								System.err.println ("Arrival exception caught : " + e ) ;
								System.exit(1) ;
						}
		}
}